/*******************************************************************************
 * FoxPickupFactoryWeapon generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxPickupFactoryWeapon extends FoxPickupFactory
    abstract
    native(Weapon)
    hidecategories(Navigation,Lighting,LightColor,Force,Attachment,Collision,Debug,Display,NavigationPoint,Object,Physics,VehicleUsage);

var FoxWeaponConfigInfo PickupConfig;
var editoronly export editinline SkeletalMeshComponent EditorWeaponComponent;
var() string WeaponPreset;
var() float RespawnTime;
var bool bRandomPickupConfig;
var bool bLocalPickup;
var repnotify byte WorldPickupIndex;

replication
{
    // Pos:0x000
    if(bNetDirty && Role == ROLE_Authority)
        WorldPickupIndex
}

simulated event ReplicatedEvent(name VarName)
{
    // End:0x2C
    if(VarName == 'WorldPickupIndex')
    {
        SetPickupConfig(WorldPickupIndex);
    }
    super(PickupFactory).ReplicatedEvent(VarName);
    //return;    
}

simulated event PreBeginPlay()
{
    ResetPickUpConfig();
    SetPickupConfigByPresetName(WeaponPreset);
    super(PickupFactory).PreBeginPlay();
    //return;    
}

simulated function SetPickupMeshByPickupConfig()
{
    local class<FoxWeapon> FoxWeaponClass;
    local editinline SkeletalMeshComponent SkelPickupMesh;
    local FoxWeaponModObjectBase PickupMod, BarrelMod;
    local editinline SkeletalMeshComponent BarrelMesh;
    local FoxDataStore_Unlockables UnlockablesDataStore;

    // End:0x9EE
    if(WorldInfo.NetMode != NM_DedicatedServer)
    {
        FoxWeaponClass = ((PickupConfig.WeaponClass != none) ? PickupConfig.WeaponClass : class<FoxWeapon>(InventoryType));
        PickupMesh = new (self) FoxWeaponClass.default.WeaponAttachmentClass.default.Mesh.Class (FoxWeaponClass.default.WeaponAttachmentClass.default.Mesh);
        // End:0x9DB
        if(FoxWeaponClass.default.WeaponType != 4)
        {
            SkelPickupMesh = SkeletalMeshComponent(PickupMesh);
            SkelPickupMesh.CastShadow = false;
            // End:0x1DD
            if(bPickupHidden)
            {
                SkelPickupMesh.SetRotation(FoxWeaponClass.default.DropPickupRotation);
                AttachComponent(PickupMesh);
                SetPickupHidden();
                return;
            }
            // End:0x316
            if(PickupConfig.WeaponBarrel != none)
            {
                BarrelMod = new (self) PickupConfig.WeaponBarrel;
                BarrelMod.GetMeshComponent(false).CastShadow = false;
                BarrelMod.SetupWeaponCamo(PickupConfig.WeaponCamoIndex);
                BarrelMesh = SkeletalMeshComponent(BarrelMod.GetMeshComponent(false));
                SkelPickupMesh.AttachComponentToSocket(BarrelMesh, FoxWeaponClass.default.BarrelSocketName);
            }
            // End:0x58F
            if(PickupConfig.WeaponMuzzle != 255)
            {
                UnlockablesDataStore = FoxDataStore_Unlockables(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxUnlockables'));
                PickupMod = new (self) class'FoxWeaponMuzzle_Base';
                PickupMod.BuildFromDataProvider(UnlockablesDataStore.MuzzleProviderArray[PickupConfig.WeaponMuzzle]);
                PickupMod.GetMeshComponent(false).CastShadow = false;
                PickupMod.SetupWeaponCamo(PickupConfig.WeaponCamoIndex);
                // End:0x532
                if(((BarrelMod != none) && BarrelMesh != none) && BarrelMesh.SkeletalMesh != none)
                {
                    BarrelMod.GetSkeletalTPMeshComp().AttachComponentToSocket(PickupMod.GetMeshComponent(false), FoxWeaponClass.default.MuzzleSocketName);
                }
                // End:0x58F
                else
                {
                    SkelPickupMesh.AttachComponentToSocket(PickupMod.GetMeshComponent(false), FoxWeaponClass.default.MuzzleSocketName);
                }
            }
            // End:0x6AC
            if(PickupConfig.WeaponStock != none)
            {
                PickupMod = new (self) PickupConfig.WeaponStock;
                PickupMod.GetMeshComponent(false).CastShadow = false;
                PickupMod.SetupWeaponCamo(PickupConfig.WeaponCamoIndex);
                SkelPickupMesh.AttachComponentToSocket(PickupMod.GetMeshComponent(false), FoxWeaponClass.default.StockSocketName);
            }
            // End:0x881
            if(PickupConfig.WeaponScope != none)
            {
                PickupMod = new (self) PickupConfig.WeaponScope;
                PickupMod.GetMeshComponent(false).CastShadow = false;
                PickupMod.SetupWeaponCamo(PickupConfig.WeaponCamoIndex);
                // End:0x824
                if(string(FoxWeaponClass.Name) ~= "FoxWeapon_Shotgun")
                {
                    SkeletalMeshComponent(BarrelMod.GetMeshComponent(false)).AttachComponentToSocket(PickupMod.GetMeshComponent(false), FoxWeaponClass.default.ScopeSocketName);
                }
                // End:0x881
                else
                {
                    SkelPickupMesh.AttachComponentToSocket(PickupMod.GetMeshComponent(false), FoxWeaponClass.default.ScopeSocketName);
                }
            }
            // End:0x99E
            if(PickupConfig.WeaponGrip != none)
            {
                PickupMod = new (self) PickupConfig.WeaponGrip;
                PickupMod.GetMeshComponent(false).CastShadow = false;
                PickupMod.SetupWeaponCamo(PickupConfig.WeaponCamoIndex);
                SkelPickupMesh.AttachComponentToSocket(PickupMod.GetMeshComponent(false), FoxWeaponClass.default.GripSocketName);
            }
            SkelPickupMesh.SetRotation(FoxWeaponClass.default.DropPickupRotation);
        }
        AttachComponent(PickupMesh);
    }
    //return;    
}

simulated function SetPickupMesh()
{
    local class<FoxWeapon> FoxWeaponClass;

    FoxWeaponClass = ((PickupConfig.WeaponClass != none) ? PickupConfig.WeaponClass : class<FoxWeapon>(InventoryType));
    // End:0xBE
    if(FoxWeaponClass != none)
    {
        // End:0x98
        if(PickupMesh != none)
        {
            DetachComponent(PickupMesh);
            PickupMesh = none;
        }
        SetPickupMeshByPickupConfig();
        SetWeaponCamo(MeshComponent(PickupMesh));
    }
    //return;    
}

simulated function SetWeaponCamo(MeshComponent CamoApplyMesh)
{
    local int I, NumTiles;
    local Texture CamoTexture;
    local array<MaterialInstanceConstant> CamoMICs;
    local float MetallicScalar;
    local bool bUseBaseColor;
    local LinearColor BaseColor;
    local float SpecularInterp;
    local editinline SkeletalMeshComponent SklMeshComponent;

    // End:0x1FD
    if((PickupConfig.WeaponCamoIndex != 255) && PickupConfig.WeaponCamoIndex != -1)
    {
        MetallicScalar = class'FoxUnlockInfo'.default.WeaponCamoUnlocks[PickupConfig.WeaponCamoIndex].MetallicInterp;
        bUseBaseColor = class'FoxUnlockInfo'.default.WeaponCamoUnlocks[PickupConfig.WeaponCamoIndex].bUseBaseColor;
        BaseColor = class'FoxUnlockInfo'.default.WeaponCamoUnlocks[PickupConfig.WeaponCamoIndex].BaseColor;
        SpecularInterp = class'FoxUnlockInfo'.default.WeaponCamoUnlocks[PickupConfig.WeaponCamoIndex].SpecularInterp;
        class'FoxUnlockInfo'.static.GetWeaponCamoTexture(CamoTexture, NumTiles, PickupConfig.WeaponCamoIndex);
    }
    // End:0x340
    else
    {
        MetallicScalar = class'FoxUnlockInfo'.default.WeaponCamoUnlocks[0].MetallicInterp;
        bUseBaseColor = class'FoxUnlockInfo'.default.WeaponCamoUnlocks[0].bUseBaseColor;
        BaseColor = class'FoxUnlockInfo'.default.WeaponCamoUnlocks[0].BaseColor;
        SpecularInterp = class'FoxUnlockInfo'.default.WeaponCamoUnlocks[0].SpecularInterp;
        class'FoxUnlockInfo'.static.GetWeaponCamoTexture(CamoTexture, NumTiles, PickupConfig.WeaponCamoIndex);
    }
    I = 0;
    J0x34B:
    // End:0x617 [Loop If]
    if(I < CamoApplyMesh.GetNumElements())
    {
        CamoMICs.AddItem(CamoApplyMesh.CreateAndSetMaterialInstanceConstant(I));
        CamoMICs[I].SetScalarParameterValue(class'FoxWeapon'.default.CamoUseSpecularParamName, SpecularInterp);
        CamoMICs[I].SetScalarParameterValue(class'FoxWeapon'.default.CamoUseBaseColorParamName, ((bUseBaseColor) ? 1.0 : 0.0));
        CamoMICs[I].SetScalarParameterValue(class'FoxWeapon'.default.CamoUseMetallicParamName, MetallicScalar);
        // End:0x51D
        if(bUseBaseColor || MetallicScalar > float(0))
        {
            CamoMICs[I].SetVectorParameterValue(class'FoxWeapon'.default.CamoBaseColorParamName, BaseColor);
        }
        // End:0x57C
        if(CamoTexture != none)
        {
            CamoMICs[I].SetTextureParameterValue(class'FoxWeapon'.default.CamoSwapParamName, CamoTexture);
        }
        CamoMICs[I].SetScalarParameterValue(class'FoxWeapon'.default.CamoTileParamName, float(NumTiles));
        CamoApplyMesh.SetMaterial(I, CamoMICs[I]);
        ++ I;
        // [Loop Continue]
        goto J0x34B;
    }
    SklMeshComponent = SkeletalMeshComponent(CamoApplyMesh);
    // End:0x720
    if(SklMeshComponent != none)
    {
        I = 0;
        J0x64D:
        // End:0x720 [Loop If]
        if(I < SklMeshComponent.Attachments.Length)
        {
            // End:0x712
            if(MeshComponent(SklMeshComponent.Attachments[I].Component) != none)
            {
                SetWeaponCamo(MeshComponent(SklMeshComponent.Attachments[I].Component));
            }
            ++ I;
            // [Loop Continue]
            goto J0x64D;
        }
    }
    //return;    
}

function SpawnCopyFor(Pawn Recipient)
{
    local FoxWeapon Inventory;

    InventoryType = ((PickupConfig.WeaponClass != none) ? PickupConfig.WeaponClass : InventoryType);
    Inventory = FoxWeapon(Spawn(InventoryType));
    // End:0x180
    if(((Inventory.WeaponType == 0) || Inventory.WeaponType == 1) || Inventory.WeaponType == 3)
    {
        FoxPRI(FoxPawn(Recipient).PlayerReplicationInfo).Loadout.SetCurrentWeaponConfig(Inventory.WeaponType, PickupConfig);
    }
    Inventory.GiveTo(Recipient);
    Inventory.AnnouncePickup(Recipient);
    ResetPickUpConfig();
    //return;    
}

function float GetRespawnTime()
{
    // End:0x1E
    if(RespawnTime > float(0))
    {
        return RespawnTime;
    }
    // End:0xAC
    else
    {
        // End:0x8D
        if(FoxMapInfo(WorldInfo.GetMapInfo()) != none)
        {
            return FoxMapInfo(WorldInfo.GetMapInfo()).WeaponPickupRespawnTime;
        }
        // End:0xAC
        else
        {
            return class'FoxMapInfo'.default.WeaponPickupRespawnTime;
        }
    }
    //return ReturnValue;    
}

// Export UFoxPickupFactoryWeapon::execSetPickupHidden(FFrame&, void* const)
native simulated function SetPickupHidden();

simulated function SetPickupVisible()
{
    bPickupHidden = false;
    SetPickupMesh();
    //return;    
}

function ResetPickUpConfig()
{
    local FoxMapInfo FMI;

    FMI = FoxMapInfo(WorldInfo.GetMapInfo());
    // End:0xCF
    if((((Role == ROLE_Authority) && bRandomPickupConfig) && FMI != none) && FMI.WeaponPresets.Length > 0)
    {
        WorldPickupIndex = byte(Rand(FMI.WeaponPresets.Length));
        SetPickupConfig(WorldPickupIndex);
    }
    //return;    
}

simulated function SetPickupConfig(int MapInfoIndex)
{
    // End:0x9D
    if(FoxMapInfo(WorldInfo.GetMapInfo()).WeaponPresets.Length > MapInfoIndex)
    {
        SetPickupConfigByPresetName(FoxMapInfo(WorldInfo.GetMapInfo()).WeaponPresets[MapInfoIndex]);
    }
    //return;    
}

// Export UFoxPickupFactoryWeapon::execSetPickupConfigByPresetName(FFrame&, void* const)
native simulated function SetPickupConfigByPresetName(string NewPresetName);

function SetRespawn()
{
    // End:0x33
    if(InventoryType.default.RespawnTime != float(0))
    {
        StartSleeping();
    }
    // End:0x41
    else
    {
        GotoState('Disabled');
    }
    //return;    
}

simulated event SetWeaponConfigFromPresetInfo(out FoxWeaponPresetInfo NewPresetInfo, out FoxWeaponConfigInfo NewConfig)
{
    NewConfig = class'FoxLoadoutInfo'.static.BuildWeaponConfigInfoFromPreset(NewPresetInfo);
    //return;    
}

defaultproperties
{
    PickupConfig=(WeaponSkin=255,WeaponClass=none,WeaponMuzzle=255,WeaponStock=none,WeaponBarrel=none,WeaponMagazine=255,WeaponScope=none,WeaponHanger=0,WeaponGrip=none,WeaponAmmo=none,WeaponCamoIndex=0)
    WorldPickupIndex=255
    begin object name=CollisionCylinder class=CylinderComponent
        CollisionHeight=30.0
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxPickupFactoryWeapon.CollisionCylinder'
    CylinderComponent=CollisionCylinder
    Components(0)=none
    Components(1)=none
    Components(2)=none
    begin object name=CollisionCylinder class=CylinderComponent
        CollisionHeight=30.0
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxPickupFactoryWeapon.CollisionCylinder'
    Components(3)=CollisionCylinder
    Components(4)=none
    begin object name=EditorMeshComponent class=SkeletalMeshComponent
        ReplacementPrimitive=none
        HiddenGame=true
    object end
    // Reference: SkeletalMeshComponent'Default__FoxPickupFactoryWeapon.EditorMeshComponent'
    Components(5)=EditorMeshComponent
    begin object name=CollisionCylinder class=CylinderComponent
        CollisionHeight=30.0
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxPickupFactoryWeapon.CollisionCylinder'
    CollisionComponent=CollisionCylinder
}